
// how we do a log slider:  we have a slider that thinks it goes from 0 to 1.
// then, whenever a value is set or requested, we re-map that value based
// upon the realMin, realMax, and base variables.  So we're basically
// filtering the values to give them a non-linear transfer function.

@interface LogSliderCell
{
	@private
	double base, realMax, realMin; // access these only via methods!
	
	// These next two are used to optimize:  log(base, max), log(base, min)
	// by caching these, we don't have to calc them every time.
	double _lbx, _lbn;
}

- setBase:(double)newBase;
- (double)base;
- setRealMax:(double)newRealMax;
- (double)realMax;
- setRealMin:(double)newRealMin;
- (double)realMin;
- (const char *)stringValue;
- setStringValue:(const char *)aString;
- (int)intValue;
- setIntValue:(int)anInt;
- (float)floatValue;
- setFloatValue:(float)aFloat;
- (double)doubleValue;
- setDoubleValue:(double)aDouble;

@end
