
#import "LogSliderCell.h"

@interface LogSliderCell(Private)

- _setLB;

@end


@implementation LogSliderCell

- _setLB
{
	_lbx = log(realMax) / log(base);
	_lbn = log(realMin) / log(base);
	return self;
}

// ***** need to implement range checking to make sure we are using sane numbers here!
- setBase:(float)newBase { base = newBase; [self _setLB]; return self; }
- (float)base { return base; }
- setRealMax:(double)newRealMax { realMax = newRealMax; [self _setLB]; return self; }
- (double)realMax  { return realMax; }
- setRealMin:(double)newRealMin { realMin = newRealMin; [self _setLB]; return self; }
- (double)realMin  { return realMin; }




// -doubleValue returns the right value and does all the work; the other
// methods generate their values from the return from -doubleValue.

// ***** These need to be implemented properly.
- (const char *)stringValue { return [super stringValue]; }
- setStringValue:(const char *)aString { return [super setStringValue:aString]; }

// These are finished:
- (int)intValue { return [self doubleValue]; }
- setIntValue:(int)anInt { return [self setDoubleValue:anInt]; }
- (float)floatValue { return [self doubleValue]; }
- setFloatValue:(float)aFloat { return [self setDoubleValue:aFloat]; }

- (double)doubleValue
{
	return pow(base, (_lbx + (1 - [super doubleValue]) * _lbn));
}

- setDoubleValue:(double)aDouble
{
	return [super setDoubleValue:
			(((log(aDouble) / log(base)) - _lbn) / (_lbx - _lbn))];
}

@end
